VERSION 5.00
Begin VB.Form Form1 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   Caption         =   "Picoscope 3000 Visual Basic Driver"
   ClientHeight    =   4905
   ClientLeft      =   2160
   ClientTop       =   3390
   ClientWidth     =   6630
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4905
   ScaleWidth      =   6630
   Begin VB.ComboBox cboVoltageB 
      Height          =   315
      Left            =   5280
      TabIndex        =   14
      Top             =   4320
      Width           =   975
   End
   Begin VB.ComboBox cboVoltageA 
      Height          =   315
      Left            =   5280
      TabIndex        =   13
      Top             =   3840
      Width           =   975
   End
   Begin VB.CommandButton Stop 
      Caption         =   "Stop Streaming"
      Height          =   495
      Left            =   5160
      TabIndex        =   12
      Top             =   2040
      Width           =   1215
   End
   Begin VB.CommandButton Slow 
      Caption         =   "Start Streaming"
      Height          =   495
      Left            =   5160
      TabIndex        =   11
      Top             =   1440
      Width           =   1215
   End
   Begin VB.CommandButton Close 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Close"
      Height          =   375
      Left            =   5160
      TabIndex        =   10
      Top             =   2760
      Width           =   1215
   End
   Begin VB.ListBox lstMessage 
      Appearance      =   0  'Flat
      Height          =   810
      Left            =   120
      TabIndex        =   6
      Top             =   3840
      Width           =   4095
   End
   Begin VB.ListBox lstChannelB 
      Appearance      =   0  'Flat
      Height          =   2760
      Left            =   2640
      TabIndex        =   5
      Top             =   600
      Width           =   2175
   End
   Begin VB.ComboBox Channel_select 
      Appearance      =   0  'Flat
      Height          =   315
      Left            =   5280
      TabIndex        =   3
      Top             =   3360
      Width           =   975
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   3600
      Top             =   1680
   End
   Begin VB.CommandButton Fast 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Fast"
      Height          =   375
      Left            =   5160
      TabIndex        =   2
      Top             =   960
      Width           =   1215
   End
   Begin VB.CommandButton Open 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Open"
      Height          =   375
      Left            =   5160
      TabIndex        =   1
      Top             =   360
      Width           =   1215
   End
   Begin VB.ListBox lstChannelA 
      Appearance      =   0  'Flat
      Height          =   2760
      Left            =   240
      TabIndex        =   0
      Top             =   600
      Width           =   2055
   End
   Begin VB.Label Label5 
      BackColor       =   &H80000009&
      Caption         =   "Voltage B"
      Height          =   255
      Left            =   4320
      TabIndex        =   16
      Top             =   4320
      Width           =   855
   End
   Begin VB.Label Label1 
      BackColor       =   &H80000009&
      Caption         =   "Voltage A"
      Height          =   255
      Left            =   4320
      TabIndex        =   15
      Top             =   3840
      Width           =   855
   End
   Begin VB.Label Label6 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Messages"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   3600
      Width           =   975
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Channel B"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   3000
      TabIndex        =   8
      Top             =   240
      Width           =   1575
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Channel A"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   480
      TabIndex        =   7
      Top             =   240
      Width           =   1575
   End
   Begin VB.Label Label2 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Channel"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   4560
      TabIndex        =   4
      Top             =   3480
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim ps4000_handle As Variant
Dim mv_a As Integer
Dim mv_b As Integer
Dim time_interval As Long
Dim time_units As Integer
Dim oversample As Integer
Dim time_indisposed As Long
Dim slow_collect As Boolean
Dim streaming As Boolean
Dim voltage_range(8) As Integer

Public Sub open_unit()
Dim S As String * 10
Dim i As Integer
Dim handle As Variant
If ps4000_handle <= 0 Then
    lstChannelA.Clear
    lstChannelB.Clear
    lstMessage.Clear
    lstMessage.AddItem ("Opening ps4000")
    
    Debug.Print " before openunit() ps 4000 less than 0"
    
    ps4000_handle = ps4000OpenUnit(handle)
    
    Debug.Print "openunit ps 4000 less than 0"
    
    If ps4000_handle > 0 Then
        lstMessage.Clear
        lstMessage.AddItem ("ps4000 opened")
    
        i = ps4000SetEts(ps4000_handle, 0, 0, 0)
        
        Debug.Print "before channel select ps 4000 greater than than 0"
        
        Call Channel_select_Click
        
        Debug.Print "before channel select ps 4000 greater than than 0"
    Else
        lstMessage.Clear
        lstMessage.AddItem ("Unable to open")
    End If
Else
    lstMessage.Clear
    lstMessage.AddItem ("ps4000 Already open")
    lstMessage.AddItem ("Handle: " & ps4000_handle)
End If

End Sub

Private Sub Channel_select_Click()
Dim channel_ok As Integer


If (Channel_select.ListIndex = 0 And ps4000_handle) Then
   channel_ok = ps4000SetChannel(ps4000_handle, 0, 1, 0, cboVoltageA.ListIndex + 2)
   channel_ok = ps4000SetChannel(ps4000_handle, 1, 0, 0, cboVoltageB.ListIndex + 2)
ElseIf (Channel_select.ListIndex = 1 And ps4000_handle) Then
   Call ps4000SetChannel(ps4000_handle, 0, 0, 1, 7)
   channel_ok = ps4000SetChannel(ps4000_handle, 0, 0, 0, cboVoltageA.ListIndex + 2)
   channel_ok = ps4000SetChannel(ps4000_handle, 1, 1, 0, cboVoltageB.ListIndex + 2)
ElseIf (Channel_select.ListIndex = 2 And ps4000_handle) Then
   Call ps4000SetChannel(ps4000_handle, 0, 1, 0, cboVoltageA.ListIndex + 2)
   Call ps4000SetChannel(ps4000_handle, 1, 1, 0, cboVoltageB.ListIndex + 2)
End If

End Sub

Private Sub Close_Click()
If (ps4000_handle > 0) Then
  ps4000Stop (ps4000_handle)
  Call ps4000CloseUnit(ps4000_handle)
  lstMessage.Clear
  lstMessage.AddItem ("ps4000 closed")
  ps4000_handle = 0
Else
  Call ps4000CloseUnit(ps4000_handle)
  lstMessage.Clear
  lstMessage.AddItem ("ps4000 Not Opened")
End If

End Sub

Private Sub Form_Initialize()
  ps4000_handle = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call ps4000CloseUnit(ps4000_handle)
End Sub

Private Sub Stop_Click()
  slow_collect = False
  ps4000Stop (ps4000_handle)
  Slow.enabled = True
End Sub


Private Sub Fast_Click()

Dim running As Integer
Dim ready As Integer
ReDim Values_a(200000) As Integer
ReDim Values_b(200000) As Integer
ReDim values_c(100) As Integer
ReDim values_d(100) As Integer
Dim volts_a As Integer
Dim volts_b As Integer
Dim no_of_values As Integer
Dim i As Integer
Dim timebase As Integer
Dim no_of_samples As Integer
Dim max_samples As Long
Dim overflow As Integer
Dim ok As Integer
'Dim max_samples As Long

Call Stop_Click

If ps4000_handle Then

   no_of_values = 1024
   timebase = 13
   
   Call Channel_select_Click
   Call ps4000SetEts(ps4000_handle, 0, 0, 0)
   ok = ps4000GetTimebase(ps4000_handle, timebase, no_of_values, time_interval, time_units, oversample, max_samples)
   ok = ps4000SetTrigger(ps4000_handle, 5, 0, 0, 0, 0)
   If ok = 0 Then
       MsgBox ("No valid data to function set_trigger")
   End If
   lstChannelA.Clear
   lstChannelB.Clear
   ok = ps4000RunBlock(ps4000_handle, no_of_values, timebase, oversample, time_indisposed)

   Do
      ready = ps4000Ready(ps4000_handle)
      If ready Then
          Exit Do
      End If
   Loop
   Call ps4000Stop(ps4000_handle)

   ok = ps4000GetValues(ps4000_handle, Values_a(0), Values_b(0), values_c(0), values_d(0), overflow, 100)
   mv_a = voltage_range(cboVoltageA.ListIndex)
   mv_b = voltage_range(cboVoltageB.ListIndex)
   For i = 0 To 99
      If Channel_select.ListIndex = 0 Or Channel_select.ListIndex = 2 Then
          volts_a = (Values_a(i) / 32767) * (mv_a)
          lstChannelA.AddItem (volts_a & " mV")
      End If
      If Channel_select.ListIndex = 1 Or Channel_select.ListIndex = 2 Then
          volts_b = (Values_b(i) / 32767) * mv_b
          lstChannelB.AddItem (volts_b & " mV")
      End If
   Next i
Else
   lstMessage.Clear
   lstMessage.AddItem ("Error running ps4000!")
End If

End Sub

Private Sub Form_Load()

voltage_range(0) = 50
voltage_range(1) = 100
voltage_range(2) = 200
voltage_range(3) = 500
voltage_range(4) = 1000
voltage_range(5) = 2000
voltage_range(6) = 5000
voltage_range(7) = 10000
voltage_range(8) = 20000

'Channel selection
Channel_select.AddItem "A", 0
Channel_select.AddItem "B", 1
Channel_select.AddItem "BOTH", 2
Channel_select.ListIndex = 0

'Channel
cboVoltageA.AddItem "50mV", 0
cboVoltageA.AddItem "100mV", 1
cboVoltageA.AddItem "200mV", 2
cboVoltageA.AddItem "500mv", 3
cboVoltageA.AddItem "1V", 4
cboVoltageA.AddItem "2V", 5
cboVoltageA.AddItem "5V", 6
cboVoltageA.AddItem "10V", 7
cboVoltageA.AddItem "20V", 8
cboVoltageA.ListIndex = 8

cboVoltageB.AddItem "50mV", 0
cboVoltageB.AddItem "100mV", 1
cboVoltageB.AddItem "200mV", 2
cboVoltageB.AddItem "500mv", 3
cboVoltageB.AddItem "1V", 4
cboVoltageB.AddItem "2V", 5
cboVoltageB.AddItem "5V", 6
cboVoltageB.AddItem "10V", 7
cboVoltageB.AddItem "20V", 8
cboVoltageB.ListIndex = 8

streaming = False

End Sub

Private Sub Open_Click()

'Dim handle As Integer
'Debug.Print ps4000OpenUnit(handle)
Call open_unit

End Sub

Private Sub Slow_Click()

Dim ok As Integer
If ps4000_handle Then
    Slow.enabled = False
    slow_collect = True
    lstChannelA.Clear
    lstChannelB.Clear
    streaming = False
End If
End Sub

Private Sub Timer1_Timer()
Dim ok As Integer
Dim overflow As Integer
ReDim Values(1) As Integer
Dim no_of_values As Integer
Dim volts_a As Integer
Dim volts_b As Integer
ReDim Values_a(1024) As Integer
ReDim Values_b(1024) As Integer
ReDim values_c(1024) As Integer
ReDim values_d(1024) As Integer
ReDim times(1024) As Long
Dim ready As Integer

If (slow_collect And ps4000_handle > 0) Then
  no_of_values = 100
  If Not streaming Then
     Call ps4000SetEts(ps4000_handle, 0, 0, 0)
     Call Channel_select_Click
     ok = ps4000SetTrigger(ps4000_handle, 0, 0, 1, 0, 0)
     If ok = 0 Then
       MsgBox ("No valid data to funktion set_trigger")
     End If
     ok = ps4000RunStreaming(ps4000_handle, 10, no_of_values, 0)
     streaming = True
  End If
   ' turn triggering off.
   no_of_values = ps4000GetValues(ps4000_handle, Values_a(0), Values_b(0), values_c(0), values_d(0), overflow, no_of_values)
   mv_a = voltage_range(cboVoltageA.ListIndex)
   mv_b = voltage_range(cboVoltageB.ListIndex)
   If Channel_select.ListIndex = 0 Or Channel_select.ListIndex = 2 Then
     For i = 0 To no_of_values - 1 Step 1
        volts_a = (Values_a(i) / 32767) * mv_a
        lstChannelA.AddItem (volts_a & Chr(9) & "mV")
     Next i
   End If
   If Channel_select.ListIndex = 1 Or Channel_select.ListIndex = 2 Then
     For i = 1 To no_of_values - 1 Step 1
        volts_b = (Values_b(i) / 32767) * mv_b
        lstChannelB.AddItem (volts_b & Chr(9) & "mV")
     Next i
   End If
End If

End Sub


